(ns com.aurellem.world.new-types
  (:use (com.aurellem.gb gb-driver util hxc characters util assembly))
  (:use (com.aurellem.world practice))
  (:import [com.aurellem.gb.gb_driver SaveState]))
  

;; GEN II type differences
;; bug against poison: 2x -> 1/2
;; poison against bug: 2x -> 1x
;; !! our article is wrong. bug against ghost 1x -X-> 2x
;; ghost against psychic: 0x -> 2x
;; ice against fire: 1x -> 1/2

;; steel against rock: 2x
;; steel against steel: 1/2
;; steel against fire : 1/2
;; steel against water: 1/2
;; steel against electric: 1/2
;; steel against ice: 2x

;; normal against steel: 1/2
;; fighting against steel: 2x
;; flying against steel: 1/2
;; poison against steel: 0
;; ground against steel: 2
;; rock against steel: 1/2
;; bug against steel: 1/2
;; ghost against steel: 1/2
;; fire against steel: 2
;; grass against steel: 1/2
;; psychic against steel: 1/2
;; ice against steel: 1/2
;; dragon against steel: 1/2
;; dark against steel: 1/2

;; dark against fighting 1/2
;; dark against ghost 2x
;; dark against steel 1/2
;; dark against psychic 2x
;; dark against dark 1/2

;; fighting against dark 1/2
;; bug against dark 2x
;; ghost against dark 1/2
;; psychic against dark 0


;; #BIRD -> #DARK at 27DE8

(defn hack-encounter
  "(BROKEN) Change the wild encounter pokemon of the given area in the current state. Volatile ---
only changes the current area, and then only as long as you remain in
  the area."
  ([pokemon]
     (hack-encounter pokemon 11))
  ([pokemon level]
     (let [id ((zipmap (hxc-pokenames) (range)) pokemon)]
       (rewrite-memory (vec(memory))
                       0xD888
                       (cons level
                             (interleave
                              (repeat 5 level)
                              (repeat (inc id)))
                              )))))
  
  
(defn hack-encounter*
  "Certainly Encounter a certain pokemon in the grass outside celadon. You must
walk out of the wild and back to load the data into RAM." 
  ([mem pkmn] (encounter mem pkmn 11))
  ([mem pkmn lvl]
  (let [pkmn-id ((zipmap (hxc-pokenames) (range)) pkmn)
        pkmn-id (if (nil? pkmn-id) 76 (inc pkmn-id))
        ] 
    (rewrite-memory
     mem
     0xCF6C
     (interleave (repeat lvl 10) (repeat pkmn-id))))))


(defn hack-gen-2-types
  []
  (->
   (vec (rom))
   (rewrite-memory 0x3E6DD [20]) ;; ghost is 2x effective against psychic
   (rewrite-memory 0x3E6C5 [5])  ;; bug is half-effective against poison
   
   ;; ice is half-effective against fire.
   ;; since this overwrites "poison is 2x against bug",
   ;; poison is now, by default, 1x effective against bug.
   (rewrite-memory 0x3E681 [25 20 5])
   
   
   (rewrite-memory 0x27DE9 ["DARK"]) ;; replace BIRD with DARK
   (rewrite-memory 0x38105 [6]) ;; BITE is a dark-type attack

   ;; the following commands write into risky unknown memory.

   (rewrite-memory 0x27DFF
                   ["STEEL" 0x50])
   
   (rewrite-memory 0x3E6f0
                   [6 1 5   ;; dark fighting 1/2
                    6 24 20 ;; dark psychic 2
                    6 8 20  ;; dark ghost 2
                    6 6 5  ;; dark dark 1/2

                    1 6 20  ;; fighting dark 2
                    24 6 0  ;; psychic dark 0
                    7 6 20  ;; bug dark 2
                    8 6 5   ;; ghost dark 1/2
                    
                    0xff
                    ])
   ;;(rewrite-rom _ 
   ;;(write-rom!)
 
   ))
  


